SystemOrganization addCategory: #SWA014!

Morph subclass: #SWA014Game
	instanceVariableNames: 'world'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Game commentStamp: 'M.V. 11/11/2016 11:51' prior: 0!
Hält instanzen von World fest.!

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'M.V. 11/30/2016 23:15'!
open
	^self new spawnPlayer; spawnEnemy; openInWorld; yourself.
	! !

!SWA014Game methodsFor: 'deleting' stamp: 'M.V. 11/30/2016 22:56'!
destroyAllEntities
	self flag: 'TODO: delete this method; this method only helps us controlling all objects, we do not need anymore for tests'.
	
	self swaworld listOfEnemies do: 
	[:x| x delete].
	self swaworld listOfEnemies: Set new.

	self swaworld swaplayer delete.
	self swaworld swaplayer: nil.
	
	self swaworld delete.
	self swaworld: nil.! !

!SWA014Game methodsFor: 'game events' stamp: 'M.V. 11/30/2016 23:51'!
gameOver
	self destroyAllEntities.
	self delete.! !

!SWA014Game methodsFor: 'initialization' stamp: 'M.V. 11/30/2016 23:50'!
initialize
	super initialize.
	
	self swaworld: SWA014World new.
	self addMorph: self swaworld.
	self swaworld game: self.
	
	self clipSubmorphs: true.
	self extent: (World bounds corner x)@(World bounds corner y). "ActiveWorld extent"! !

!SWA014Game methodsFor: 'spawning' stamp: 'TZ 12/2/2016 16:32'!
spawnEnemy
"spawns SWA014Enemys up to the specified number"
|enemy random r1 r2 r3 MAXSIZE NUMBER_OF_ENEMIES|
MAXSIZE := 75.
NUMBER_OF_ENEMIES := 10.

1 to: NUMBER_OF_ENEMIES  do:
[:x|	
	enemy := SWA014Enemy new openInWorld.
	random := Random new.
	r1 := random nextInt: 1920.
	r2 := random nextInt: 1080.
	r3 := random nextInt: MAXSIZE.
	r1 := r1 * 1.001.
	r2 := r2 * 1.001.
	r3 := r3 * 1.001.
	Transcript show: r1.
	enemy realPosition: (r1@r2).
	enemy thingSize: r3.
	enemy swaworld: self swaworld.
	enemy boundDetected: 0.
	self swaworld listOfEnemies add: enemy.
	self swaworld addMorph: enemy.
].! !

!SWA014Game methodsFor: 'spawning' stamp: 'TZ 12/2/2016 16:28'!
spawnPlayer
	|newPlayer|
	newPlayer := SWA014Player new openInWorld.
	newPlayer color: Color red.
	newPlayer thingSize: 50.
	newPlayer realPosition: "0.0@0.0." ((World bounds width / 2 + 0.001)@(World bounds height / 2 + 0.001)) "(self swaworld center x * 1.001 @ self swaworld center y * 1.001)".
	newPlayer swaworld: self swaworld.
	newPlayer boundDetected: 0.
	self swaworld swaplayer: newPlayer.
	self swaworld addMorph: newPlayer.! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 11/11/2016 14:35'!
spawnPowerup
self flag: 'TODO: implement; this is an extension and shouldn''t be implemented until the basic game works'.! !

!SWA014Game methodsFor: 'spawning' stamp: 'TZ 12/2/2016 14:39'!
start
	self spawnPlayer.
	"self spawnEnemy."! !

!SWA014Game methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:21'!
swaworld
	^world.! !

!SWA014Game methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:21'!
swaworld: x
	world := x.! !

CircleMorph subclass: #SWA014LivingThing
	instanceVariableNames: 'size speed id direction world currentStep realPosition boundDetected thingSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014LivingThing commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein sich aktiv bewegendes am Spiel teilnehmendes Object.!

SWA014LivingThing subclass: #SWA014Enemy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Enemy commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein Konkurrent im Spiel.!

!SWA014Enemy methodsFor: 'movement' stamp: 'TZ 12/2/2016 15:18'!
"Enemys should follow the nearest object, which could be eaten by them. Also they should run away, if there is a bigger LivingThing (Player or Enemy) nearby."

calculateMovement: target
	super calculateMovement: target realPosition.
	
	target thingSize >= self thingSize
	ifTrue:
	 [
		self direction: (0.0@0.0) - self direction.
	].
	! !

!SWA014Enemy methodsFor: 'vision' stamp: 'TZ 12/2/2016 15:48'!
nearestEnemy
	|smallestDistance nearestEnemyobject allEnemies currentDistance BIGNUMBER|
	
	BIGNUMBER := SmallInteger maxVal.
	smallestDistance := BIGNUMBER.
	nearestEnemyobject := self.
	
	allEnemies := Set new.
	allEnemies := self swaworld listOfEnemies copy.
	allEnemies add: self swaworld swaplayer.
	
	allEnemies do: 
	[:enemy| 
	currentDistance := self distanceTo: enemy realPosition.
	((currentDistance  < smallestDistance) and: (currentDistance ~~ 0))
	ifTrue: [smallestDistance := currentDistance.
			nearestEnemyobject := enemy.]
	].

	^nearestEnemyobject.! !

!SWA014Enemy methodsFor: 'override' stamp: 'TZ 12/2/2016 15:33'!
step
	"self currentStep > self stepNumber
	ifTrue:
	["
		self calculateMovement: self nearestEnemy.
		self moveAutomatically.
		self currentStep: 0.
	"] 
	ifFalse:
	[
		self currentStep: self currentStep + 1.
	]."
	
	super step.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 22:59'!
bodysize 
	^bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'M.V. 11/30/2016 23:00'!
bodysize: x
	|MAX_ALLOWED_SIZE MIN_ALLOWED_SIZE|
	
	MAX_ALLOWED_SIZE := 1000.
	MIN_ALLOWED_SIZE := 10.
	
	x < MAX_ALLOWED_SIZE
	ifTrue: 
	[
		x > MIN_ALLOWED_SIZE
		ifTrue: 
		[
			bodysize := x.
		]
		ifFalse: 
		[
			bodysize := MIN_ALLOWED_SIZE.
		].		
	]
	ifFalse:
	[
		bodysize := MAX_ALLOWED_SIZE.
	] .
	! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'TZ 12/2/2016 15:25'!
boundDetected
	^boundDetected! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'Tc 11/30/2016 22:50'!
boundDetected: aValue
	boundDetected := aValue! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 12/2/2016 15:02'!
calculateMovement: target
	|directionVector deltaX deltaY distance|
		
	deltaX := ((target x + 0.001) - self realPosition x).
	deltaY := ((target y + 0.001) - self realPosition y).
	
	distance := ((deltaX * deltaX) + (deltaY * deltaY)) sqrt. "self distanceTo: target."
	distance = 0.0 ifTrue: [distance := 1.0.]. "prevent us from dividing by zero"
	
	directionVector := ((deltaX/distance)@(deltaY/distance)).
	
	self direction: directionVector * 2.0.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'TZ 12/2/2016 15:50'!
checkForCollisions
	|radius listOfLivingThings|
	
	radius := self thingSize/2.	
	listOfLivingThings := Set new.
	listOfLivingThings := self swaworld listOfEnemies copy.
	listOfLivingThings add: self swaworld swaplayer.
	
	"listOfLivingThings do:
	[	
		:enemy|
		(enemy ~~ self) ifTrue: 
		[
			(enemy thingSize < self thingSize) ifTrue: 
			[
				((self distanceTo: enemy realPosition) < radius) ifTrue: 
				[
					self eat: enemy.
				]
			]
		]
	]"! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/24/2016 20:53'!
currentStep
	^currentStep.! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/24/2016 20:52'!
currentStep: x
	currentStep := x.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:45'!
direction
	^direction.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/11/2016 14:44'!
direction: x
	direction := x.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'TZ 11/25/2016 14:51'!
distanceTo: enemy
	^(((self realPosition x - self realPosition x) raisedTo: 2)+
	((enemy y - self realPosition y) raisedTo: 2)) sqrt. "Pythagoras' theorem"! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'TZ 12/2/2016 15:51'!
eat: prey
	self thingSize: 2* (((self thingSize / 2) raisedTo: 2) + ((prey thingSize / 2) raisedTo: 2)) sqrt.

	self swaworld listOfEnemies: 
		(self swaworld listOfEnemies reject: [:enemy| enemy == prey]).
	(prey ~~ self swaworld swaplayer) 
	ifTrue: 
	[
		prey delete.
	]
	ifFalse: 
	[
		self swaworld game gameOver.
	].! !

!SWA014LivingThing methodsFor: 'initialization' stamp: 'TZ 11/25/2016 15:08'!
initialize
	super initialize.
	self currentStep: 0.0.
	self speed: 60.0.
	self direction: (0.0@0.0).
	self realPosition: (0.0@0.0).! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 12/2/2016 16:21'!
moveAutomatically
	self realPosition: self realPosition + (self direction).
	self center: self realPosition + self swaworld realPosition.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 11/25/2016 14:42'!
realPosition
	^realPosition.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 11/25/2016 14:43'!
realPosition: pos
	realPosition := pos.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'Tc 11/30/2016 22:59'!
refreshSize
	self extent: (self thingSize)@(self thingSize).
	
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'M.V. 11/4/2016 12:37'!
speed
	^speed.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 11/25/2016 14:46'!
speed: x
	|MAX_ALLOWED_SPEED MIN_ALLOWED_SPEED|
	
	MAX_ALLOWED_SPEED := 1000.0.
	MIN_ALLOWED_SPEED := 1.0.
	
	x < MAX_ALLOWED_SPEED
	ifTrue: 
	[
		x> MIN_ALLOWED_SPEED
		ifTrue: 
		[
			 speed := x.
		]
	 	ifFalse:
		[
			speed := MIN_ALLOWED_SPEED.
		].
	]
	ifFalse:
	[
		speed := MAX_ALLOWED_SPEED.
	] .
	! !

!SWA014LivingThing methodsFor: 'override' stamp: 'Tc 12/2/2016 11:54'!
step
	self checkForCollisions.
	self refreshSize.! !

!SWA014LivingThing methodsFor: 'override' stamp: 'TZ 12/2/2016 15:30'!
stepNumber
	"This is used to keep the stepTime up to date"
	
	"self speed ~= 0
	ifTrue:
	[
		^5.0 * (self size sqrt)  / self speed.	
	]
	ifFalse: 
	[
		^SmallInteger maxVal.	Stops stepping
	].
	"! !

!SWA014LivingThing methodsFor: 'override' stamp: 'M.V. 11/18/2016 14:38'!
stepTime
	^1! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:12'!
swaworld
	^world.! !

!SWA014LivingThing methodsFor: 'accessors' stamp: 'M.V. 11/18/2016 13:12'!
swaworld: x
	world := x.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'TZ 12/2/2016 15:26'!
thingSize 
	^thingSize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'Tc 11/30/2016 22:58'!
thingSize: x
	|MAX_ALLOWED_SIZE MIN_ALLOWED_SIZE|
	
	MAX_ALLOWED_SIZE := 1000.
	MIN_ALLOWED_SIZE := 10.
	
	x < MAX_ALLOWED_SIZE
	ifTrue: 
	[
		x > MIN_ALLOWED_SIZE
		ifTrue: 
		[
			thingSize := x.
		]
		ifFalse: 
		[
			thingSize := MIN_ALLOWED_SIZE.
		].		
	]
	ifFalse:
	[
		thingSize := MAX_ALLOWED_SIZE.
	] .
	! !

SWA014LivingThing subclass: #SWA014Player
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Player commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Der Spieler.!

!SWA014Player methodsFor: 'movement' stamp: 'TZ 12/2/2016 16:13'!
moveAutomatically
	self swaworld realPosition: self swaworld realPosition - self direction.
	self swaworld position: self swaworld realPosition.
	self realPosition: self realPosition + self direction.
	"Transcript show: self center; cr."
	self center: self realPosition + self swaworld realPosition.! !

!SWA014Player methodsFor: 'as yet unclassified' stamp: 'M.V. 11/4/2016 12:42'!
number
	^number.! !

!SWA014Player methodsFor: 'as yet unclassified' stamp: 'M.V. 11/4/2016 12:41'!
number: x
	number := x.! !

!SWA014Player methodsFor: 'override' stamp: 'TZ 12/2/2016 16:27'!
step
	super step.
	Transcript show: World activeHand center; cr.
	self calculateMovement: World activeHand center - (((World bounds width)@(World bounds height)) / 2.0) + self realPosition.
	self moveAutomatically.! !

ImageMorph subclass: #SWA014World
	instanceVariableNames: 'size listOfEnemies game realPosition worldSize swaplayer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014World commentStamp: 'M.V. 11/11/2016 11:52' prior: 0!
Die Welt in der gespielt wird. Sie beinhaltet Feinde und hat eine gewisse Größe.!

!SWA014World methodsFor: 'as yet unclassified' stamp: 'TZ 12/2/2016 16:34'!
checkForBorderCollisions
	"self listOfEnemies do: 
	[:enemy | 
	(enemy bounds right >= self bounds right) ifTrue: [enemy  center: ((self bounds right-100)@(enemy center y))].
	
	(enemy bounds top <= self bounds top) ifTrue: [enemy  center: ((enemy center x)@(self bounds top+100))].
	
	(enemy bounds left <= self bounds left) ifTrue: [enemy  center: ((self bounds left+100)@(enemy center y))].
	
	(enemy bounds bottom >= self bounds bottom) ifTrue: [enemy  center: ((enemy center y)@(self bounds bottom-100))].
	]."! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game
	^game.! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game: x
	game := x.! !

!SWA014World methodsFor: 'initialization' stamp: 'TZ 12/2/2016 16:29'!
initialize
	|aForm|
	super initialize.
	aForm := ImageReadWriter formFromFileNamed: 'Chrysanthemum.jpg'.
	self newForm: aForm.
	self listOfEnemies: Set new.
	self swaplayer: nil.
	self worldSize: 3000.
	self extent: (self worldSize @ self worldSize).
	self center: ((World bounds corner x / 2)@(World bounds corner y / 2)).
	"self realPosition: ((self center x + 0.001)@(self center y / 2 + 0.001))."
	self realPosition: 0.0@0.0.
	self openInWorld.
	self color: Color transparent.
	
	
! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/4/2016 14:37'!
listOfEnemies
	^ listOfEnemies! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/4/2016 14:37'!
listOfEnemies: anObject
	listOfEnemies := anObject! !

!SWA014World methodsFor: 'as yet unclassified' stamp: 'TZ 11/25/2016 15:34'!
realPosition
	^realPosition.! !

!SWA014World methodsFor: 'as yet unclassified' stamp: 'TZ 11/25/2016 15:35'!
realPosition: x
	realPosition := x.! !

!SWA014World methodsFor: 'as yet unclassified' stamp: 'Tc 12/2/2016 12:03'!
step
	self checkForBorderCollisions.! !

!SWA014World methodsFor: 'as yet unclassified' stamp: 'Tc 12/2/2016 15:02'!
stepTime
	^100! !

!SWA014World methodsFor: 'world content' stamp: 'TZ 12/2/2016 15:52'!
swaplayer
	^swaplayer.! !

!SWA014World methodsFor: 'world content' stamp: 'M.V. 11/30/2016 22:55'!
swaplayer: x
	swaplayer := x.! !

!SWA014World methodsFor: 'accessing' stamp: 'TZ 12/2/2016 15:52'!
worldSize
	^worldSize! !

!SWA014World methodsFor: 'accessing' stamp: 'Tc 11/30/2016 20:32'!
worldSize: anObject
	worldSize := anObject! !
